Parcourir la source

First beta, without arguments checking (install and web admin)

Julien VAUBOURG il y a 10 ans
Parent
commit
979a09ba8c
40 fichiers modifiés avec 13856 ajouts et 29 suppressions
  1. 1 1
      conf/hostapd.conf.tpl
  2. 9 11
      conf/init_ynh-hotspot
  3. 19 0
      conf/nginx_wifiadmin.conf
  4. 242 0
      conf/phpfpm_wifiadmin.conf
  5. 15 0
      manifest.json
  6. 63 15
      scripts/install
  7. 18 2
      scripts/remove
  8. 56 0
      sources/config.php
  9. 90 0
      sources/controller.php
  10. 3 0
      sources/i18n/README
  11. 11 0
      sources/index.php
  12. 2707 0
      sources/lib/limonade.php
  13. 193 0
      sources/lib/limonade/abstract.php
  14. 173 0
      sources/lib/limonade/assertions.php
  15. 220 0
      sources/lib/limonade/public/css/screen.css
  16. BIN
      sources/lib/limonade/public/img/bg_header.png
  17. 350 0
      sources/lib/limonade/tests.php
  18. 37 0
      sources/lib/limonade/views/_debug.html.php
  19. 15 0
      sources/lib/limonade/views/_notices.html.php
  20. 22 0
      sources/lib/limonade/views/default_layout.php
  21. 6 0
      sources/lib/limonade/views/error.html.php
  22. 49 0
      sources/lib/unix_func.php
  23. 457 0
      sources/public/bootstrap/css/bootstrap-theme.css
  24. 1 0
      sources/public/bootstrap/css/bootstrap-theme.css.map
  25. 5 0
      sources/public/bootstrap/css/bootstrap-theme.min.css
  26. 6358 0
      sources/public/bootstrap/css/bootstrap.css
  27. 1 0
      sources/public/bootstrap/css/bootstrap.css.map
  28. 5 0
      sources/public/bootstrap/css/bootstrap.min.css
  29. BIN
      sources/public/bootstrap/fonts/glyphicons-halflings-regular.eot
  30. 229 0
      sources/public/bootstrap/fonts/glyphicons-halflings-regular.svg
  31. BIN
      sources/public/bootstrap/fonts/glyphicons-halflings-regular.ttf
  32. BIN
      sources/public/bootstrap/fonts/glyphicons-halflings-regular.woff
  33. 2276 0
      sources/public/bootstrap/js/bootstrap.js
  34. 7 0
      sources/public/bootstrap/js/bootstrap.min.js
  35. 13 0
      sources/public/bootstrap/js/npm.js
  36. 0 0
      sources/public/css/style.css
  37. 4 0
      sources/public/jquery/jquery-2.1.1.min.js
  38. 29 0
      sources/public/js/custom.js
  39. 39 0
      sources/views/layout.html.php
  40. 133 0
      sources/views/settings.html.php

+ 1 - 1
conf/hostapd.conf.tpl

@@ -1,7 +1,7 @@
 interface=<TPL:WIFI_DEVICE>
 ssid=<TPL:WIFI_SSID>
 hw_mode=g
-channel=6
+channel=<TPL:WIFI_CHANNEL>
 macaddr_acl=0
 auth_algs=1
 ignore_broadcast_ssid=0

+ 9 - 11
conf/init_ynh-hotspot

@@ -18,7 +18,7 @@ is_ndproxy_set() {
 }
 
 is_nat_set() {
-  internet_device=$1
+  internet_device=${1}
 
   iptables -nvt nat -L POSTROUTING | grep MASQUERADE | grep -q "${internet_device}"
 }
@@ -63,7 +63,7 @@ set_ndproxy() {
 }
 
 set_nat() {
-  internet_device=$1
+  internet_device=${1}
 
   iptables -t nat -A POSTROUTING -o "${internet_device}" -j MASQUERADE
 }
@@ -87,6 +87,7 @@ start_hostapd() {
   sed "s|<TPL:WIFI_DEVICE>|${ynh_wifi_device}|g" -i /etc/hostapd/hostapd.conf
   sed "s|<TPL:WIFI_SSID>|${ynh_wifi_ssid}|g" -i /etc/hostapd/hostapd.conf
   sed "s|<TPL:WIFI_PASSPHRASE>|${ynh_wifi_passphrase}|g" -i /etc/hostapd/hostapd.conf
+  sed "s|<TPL:WIFI_CHANNEL>|${ynh_wifi_channel}|g" -i /etc/hostapd/hostapd.conf
 
   service hostapd start
 }
@@ -120,7 +121,7 @@ unset_ndproxy() {
 }
 
 unset_nat() {
-  internet_device=$1
+  internet_device=${1}
 
   iptables -t nat -D POSTROUTING -o "${internet_device}" -j MASQUERADE
 }
@@ -153,7 +154,7 @@ stop_dhcpd() {
 ## Tools
 
 moulinette_get() {
-  var=$1
+  var=${1}
 
   value=$(yunohost app setting hotspot "${var}")
 
@@ -166,8 +167,8 @@ moulinette_get() {
 } 
 
 moulinette_set() {
-  var=$1
-  value=$2
+  var=${1}
+  value=${2}
 
   msg=$(yunohost app setting hotspot "${var}" -v "${value}")
 
@@ -184,6 +185,7 @@ echo -n "Retrieving Yunohost settings... "
 ynh_wifi_device=$(moulinette_get wifi_device)
 ynh_wifi_ssid=$(moulinette_get wifi_ssid)
 ynh_wifi_passphrase=$(moulinette_get wifi_passphrase)
+ynh_wifi_channel=$(moulinette_get wifi_channel)
 ynh_ip6_addr=$(moulinette_get ip6_addr)
 ynh_ip6_net=$(moulinette_get ip6_net)
 ynh_ip6_dns0=$(moulinette_get ip6_dns0)
@@ -317,10 +319,6 @@ case "$1" in
       stop_dhcpd
     fi
   ;;
-  restart)
-    $0 stop
-    $0 start
-  ;;
   status)
     exitcode=0
 
@@ -383,7 +381,7 @@ case "$1" in
     exit ${exitcode}
   ;;
   *)
-    echo "Usage: $0 {start|stop|restart|status}"
+    echo "Usage: $0 {start|stop|status}"
     exit 1
   ;;
 esac

+ 19 - 0
conf/nginx_wifiadmin.conf

@@ -0,0 +1,19 @@
+location <TPL:NGINX_LOCATION> {
+       alias <TPL:NGINX_REALPATH>;
+       if ($scheme = http) {
+           rewrite ^ https://$server_name$request_uri? permanent;
+       }
+       client_max_body_size 10G;
+       index index.php;
+       try_files $uri $uri/ index.php;
+       location ~ [^/]\.php(/|$) {
+           fastcgi_split_path_info ^(.+?\.php)(/.*)$;
+           fastcgi_pass unix:/var/run/php5-fpm-<TPL:PHP_NAME>.sock;
+           fastcgi_index index.php;
+           include fastcgi_params;
+           fastcgi_read_timeout 600;
+           fastcgi_param   REMOTE_USER   $remote_user;
+           fastcgi_param  PATH_INFO $fastcgi_path_info;
+       }
+       include conf.d/yunohost_panel.conf.inc;
+}

+ 242 - 0
conf/phpfpm_wifiadmin.conf

@@ -0,0 +1,242 @@
+; Start a new pool named 'www'.
+; the variable $pool can we used in any directive and will be replaced by the
+; pool name ('www' here)
+[<TPL:PHP_NAME>]
+
+; Per pool prefix
+; It only applies on the following directives:
+; - 'slowlog'
+; - 'listen' (unixsocket)
+; - 'chroot'
+; - 'chdir'
+; - 'php_values'
+; - 'php_admin_values'
+; When not set, the global prefix (or /usr) applies instead.
+; Note: This directive can also be relative to the global prefix.
+; Default Value: none
+;prefix = /path/to/pools/$pool
+
+; The address on which to accept FastCGI requests.
+; Valid syntaxes are:
+;   'ip.add.re.ss:port'    - to listen on a TCP socket to a specific address on
+;                            a specific port;
+;   'port'                 - to listen on a TCP socket to all addresses on a
+;                            specific port;
+;   '/path/to/unix/socket' - to listen on a unix socket.
+; Note: This value is mandatory.
+listen = /var/run/php5-fpm-<TPL:PHP_NAME>.sock
+
+; Set listen(2) backlog. A value of '-1' means unlimited.
+; Default Value: 128 (-1 on FreeBSD and OpenBSD)
+;listen.backlog = -1
+
+; List of ipv4 addresses of FastCGI clients which are allowed to connect.
+; Equivalent to the FCGI_WEB_SERVER_ADDRS environment variable in the original
+; PHP FCGI (5.2.2+). Makes sense only with a tcp listening socket. Each address
+; must be separated by a comma. If this value is left blank, connections will be
+; accepted from any ip address.
+; Default Value: any
+;listen.allowed_clients = 127.0.0.1
+
+; Set permissions for unix socket, if one is used. In Linux, read/write
+; permissions must be set in order to allow connections from a web server. Many
+; BSD-derived systems allow connections regardless of permissions.
+; Default Values: user and group are set as the running user
+;                 mode is set to 0666
+listen.owner = www-data
+listen.group = www-data
+listen.mode = 0600
+
+; Unix user/group of processes
+; Note: The user is mandatory. If the group is not set, the default user's group
+;       will be used.
+user = <TPL:PHP_USER>
+group = <TPL:PHP_GROUP>
+
+; Choose how the process manager will control the number of child processes.
+; Possible Values:
+;   static  - a fixed number (pm.max_children) of child processes;
+;   dynamic - the number of child processes are set dynamically based on the
+;             following directives:
+;             pm.max_children      - the maximum number of children that can
+;                                    be alive at the same time.
+;             pm.start_servers     - the number of children created on startup.
+;             pm.min_spare_servers - the minimum number of children in 'idle'
+;                                    state (waiting to process). If the number
+;                                    of 'idle' processes is less than this
+;                                    number then some children will be created.
+;             pm.max_spare_servers - the maximum number of children in 'idle'
+;                                    state (waiting to process). If the number
+;                                    of 'idle' processes is greater than this
+;                                    number then some children will be killed.
+; Note: This value is mandatory.
+pm = dynamic
+
+; The number of child processes to be created when pm is set to 'static' and the
+; maximum number of child processes to be created when pm is set to 'dynamic'.
+; This value sets the limit on the number of simultaneous requests that will be
+; served. Equivalent to the ApacheMaxClients directive with mpm_prefork.
+; Equivalent to the PHP_FCGI_CHILDREN environment variable in the original PHP
+; CGI.
+; Note: Used when pm is set to either 'static' or 'dynamic'
+; Note: This value is mandatory.
+pm.max_children = 6
+
+; The number of child processes created on startup.
+; Note: Used only when pm is set to 'dynamic'
+; Default Value: min_spare_servers + (max_spare_servers - min_spare_servers) / 2
+pm.start_servers = 3
+
+; The desired minimum number of idle server processes.
+; Note: Used only when pm is set to 'dynamic'
+; Note: Mandatory when pm is set to 'dynamic'
+pm.min_spare_servers = 3
+
+; The desired maximum number of idle server processes.
+; Note: Used only when pm is set to 'dynamic'
+; Note: Mandatory when pm is set to 'dynamic'
+pm.max_spare_servers = 5
+
+; The number of requests each child process should execute before respawning.
+; This can be useful to work around memory leaks in 3rd party libraries. For
+; endless request processing specify '0'. Equivalent to PHP_FCGI_MAX_REQUESTS.
+; Default Value: 0
+pm.max_requests = 500
+
+; The URI to view the FPM status page. If this value is not set, no URI will be
+; recognized as a status page. By default, the status page shows the following
+; information:
+;   accepted conn        - the number of request accepted by the pool;
+;   pool                 - the name of the pool;
+;   process manager      - static or dynamic;
+;   idle processes       - the number of idle processes;
+;   active processes     - the number of active processes;
+;   total processes      - the number of idle + active processes.
+;   max children reached - number of times, the process limit has been reached,
+;                          when pm tries to start more children (works only for
+;                          pm 'dynamic')
+; The values of 'idle processes', 'active processes' and 'total processes' are
+; updated each second. The value of 'accepted conn' is updated in real time.
+; Example output:
+;   accepted conn:        12073
+;   pool:                 www
+;   process manager:      static
+;   idle processes:       35
+;   active processes:     65
+;   total processes:      100
+;   max children reached: 1
+; By default the status page output is formatted as text/plain. Passing either
+; 'html' or 'json' as a query string will return the corresponding output
+; syntax. Example:
+;   http://www.foo.bar/status
+;   http://www.foo.bar/status?json
+;   http://www.foo.bar/status?html
+; Note: The value must start with a leading slash (/). The value can be
+;       anything, but it may not be a good idea to use the .php extension or it
+;       may conflict with a real PHP file.
+; Default Value: not set
+pm.status_path = /fpm-status
+
+; The ping URI to call the monitoring page of FPM. If this value is not set, no
+; URI will be recognized as a ping page. This could be used to test from outside
+; that FPM is alive and responding, or to
+; - create a graph of FPM availability (rrd or such);
+; - remove a server from a group if it is not responding (load balancing);
+; - trigger alerts for the operating team (24/7).
+; Note: The value must start with a leading slash (/). The value can be
+;       anything, but it may not be a good idea to use the .php extension or it
+;       may conflict with a real PHP file.
+; Default Value: not set
+ping.path = /ping
+
+; This directive may be used to customize the response of a ping request. The
+; response is formatted as text/plain with a 200 response code.
+; Default Value: pong
+;ping.response = pong
+
+; The timeout for serving a single request after which the worker process will
+; be killed. This option should be used when the 'max_execution_time' ini option
+; does not stop script execution for some reason. A value of '0' means 'off'.
+; Available units: s(econds)(default), m(inutes), h(ours), or d(ays)
+; Default Value: 0
+request_terminate_timeout = 600s
+
+; The timeout for serving a single request after which a PHP backtrace will be
+; dumped to the 'slowlog' file. A value of '0s' means 'off'.
+; Available units: s(econds)(default), m(inutes), h(ours), or d(ays)
+; Default Value: 0
+request_slowlog_timeout = 5s
+
+; The log file for slow requests
+; Default Value: not set
+; Note: slowlog is mandatory if request_slowlog_timeout is set
+slowlog = /var/log/nginx/<TPL:PHP_NAME>.slow.log
+
+; Set open file descriptor rlimit.
+; Default Value: system defined value
+rlimit_files = 4096
+
+; Set max core size rlimit.
+; Possible Values: 'unlimited' or an integer greater or equal to 0
+; Default Value: system defined value
+rlimit_core = 0
+
+; Chroot to this directory at the start. This value must be defined as an
+; absolute path. When this value is not set, chroot is not used.
+; Note: you can prefix with '$prefix' to chroot to the pool prefix or one
+; of its subdirectories. If the pool prefix is not set, the global prefix
+; will be used instead.
+; Note: chrooting is a great security feature and should be used whenever
+;       possible. However, all PHP paths will be relative to the chroot
+;       (error_log, sessions.save_path, ...).
+; Default Value: not set
+;chroot =
+
+; Chdir to this directory at the start.
+; Note: relative path can be used.
+; Default Value: current directory or / when chroot
+chdir = <TPL:NGINX_REALPATH>
+
+; Redirect worker stdout and stderr into main error log. If not set, stdout and
+; stderr will be redirected to /dev/null according to FastCGI specs.
+; Note: on highloaded environement, this can cause some delay in the page
+; process time (several ms).
+; Default Value: no
+catch_workers_output = yes
+
+; Pass environment variables like LD_LIBRARY_PATH. All $VARIABLEs are taken from
+; the current environment.
+; Default Value: clean env
+;env[HOSTNAME] = $HOSTNAME
+;env[PATH] = /usr/local/bin:/usr/bin:/bin
+;env[TMP] = /tmp
+;env[TMPDIR] = /tmp
+;env[TEMP] = /tmp
+
+; Additional php.ini defines, specific to this pool of workers. These settings
+; overwrite the values previously defined in the php.ini. The directives are the
+; same as the PHP SAPI:
+;   php_value/php_flag             - you can set classic ini defines which can
+;                                    be overwritten from PHP call 'ini_set'.
+;   php_admin_value/php_admin_flag - these directives won't be overwritten by
+;                                     PHP call 'ini_set'
+; For php_*flag, valid values are on, off, 1, 0, true, false, yes or no.
+
+; Defining 'extension' will load the corresponding shared extension from
+; extension_dir. Defining 'disable_functions' or 'disable_classes' will not
+; overwrite previously defined php.ini values, but will append the new value
+; instead.
+
+; Note: path INI options can be relative and will be expanded with the prefix
+; (pool, global or /usr)
+
+; Default Value: nothing is defined by default except the values in php.ini and
+;                specified at startup with the -d argument
+;php_admin_value[sendmail_path] = /usr/sbin/sendmail -t -i -f www@my.domain.com
+;php_flag[display_errors] = off
+;php_admin_value[error_log] = /var/log/fpm-php.www.log
+;php_admin_flag[log_errors] = on
+;php_admin_value[memory_limit] = 32M
+
+php_value[upload_max_filesize] = 10G
+php_value[post_max_size] = 10G

+ 15 - 0
manifest.json

@@ -15,6 +15,21 @@
   "arguments": {
     "install" : [
       {
+        "name": "Domain",
+        "ask": {
+            "en": "Choose a domain for your Wifi web administration"
+        },
+        "example": "domain.org"
+      },
+      {
+        "name": "URL Path",
+        "ask": {
+            "en": "Choose a path for your Wifi web administration"
+        },
+        "example": "/wifiadmin",
+        "default": "/wifiadmin"
+      },
+      {
         "name": "Wifi SSID",
         "ask": {
             "en": "Choose an SSID"

+ 63 - 15
scripts/install

@@ -1,22 +1,29 @@
-#!/bin/bash
+#wifiadmin!/bin/bash
 
 # Retrieve arguments
-wifi_ssid=$1
-wifi_passphrase=$2
-wifi_device=$3
-ip6_net=$4
-ip6_dns0=$5
-ip6_dns1=$6
-ip4_dns0=$7
-ip4_dns1=$8
+domain=${1}
+url_path=${2}
+wifi_ssid=${3}
+wifi_passphrase=${4}
+wifi_device=${5}
+ip6_net=${6}
+ip6_dns0=${7}
+ip6_dns1=${8}
+ip4_dns0=${9}
+ip4_dns1=${10}
 
 # Check arguments
 # TODO
 
+sudo yunohost app checkurl ${domain}${url_path} -a hotspot 
+if [ ! $? -eq 0 ]; then
+  exit 1
+fi
+
 # Install packages
 # TODO: Replace isc-dhcp-server by dnsmasq (currently negotiating with the YunoHost team to
 # also replace bind9 by dnsmasq)
-sudo apt-get --assume-yes --force-yes install hostapd radvd isc-dhcp-server iptables
+sudo apt-get --assume-yes --force-yes install hostapd radvd isc-dhcp-server iptables php5-fpm
 
 # Install extra packages
 sudo apt-get --assume-yes --force-yes install sipcalc
@@ -28,10 +35,11 @@ ip6_addr=$(echo "$(echo "${ip6_expanded_net}" | cut -d: -f1-7):1")
 ip6_addr=$(sipcalc "${ip6_addr}" | grep Compressed | awk '{ print $NF; }')
 ip4_nat_prefix=10.0.242
 
-# Save arguments for future upgrades
+# Save arguments
 sudo yunohost app setting hotspot wifi_ssid -v "${wifi_ssid}"
 sudo yunohost app setting hotspot wifi_passphrase -v "${wifi_passphrase}"
 sudo yunohost app setting hotspot wifi_device -v "${wifi_device}"
+sudo yunohost app setting hotspot wifi_channel -v 6
 sudo yunohost app setting hotspot ip6_addr -v "${ip6_addr}"
 sudo yunohost app setting hotspot ip6_net -v "${ip6_net}"
 sudo yunohost app setting hotspot ip6_dns0 -v "${ip6_dns0}"
@@ -44,13 +52,42 @@ sudo yunohost app setting hotspot ip4_nat_prefix -v "${ip4_nat_prefix}"
 sudo install -b -o root -g root -m 0644 ../conf/hostapd.conf.tpl /etc/hostapd/
 sudo install -b -o root -g root -m 0644 ../conf/radvd.conf.tpl /etc/
 sudo install -b -o root -g root -m 0644 ../conf/dhcpd.conf.tpl /etc/dhcp/
+sudo install -b -o root -g root -m 0644 ../conf/nginx_wifiadmin.conf "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
+sudo install -b -o root -g root -m 0644 ../conf/phpfpm_wifiadmin.conf /etc/php5/fpm/pool.d/wifiadmin.conf
 
-# Copy init script
-sudo install -b -o root -g root -m 0755 ../conf/init_ynh-hotspot /etc/init.d/ynh-hotspot
+# Copy web sources
+sudo mkdir -pm 0755 /var/www/wifiadmin/
+sudo cp -a ../sources/* /var/www/wifiadmin/
+
+sudo chown -R root: /var/www/wifiadmin/
+sudo chmod -R 0644 /var/www/wifiadmin/*
+sudo find /var/www/wifiadmin/ -type d -exec chmod +x {} \;
 
+# Create user for the web admin
+sudo useradd -MUr wifiadmin
+
+# Fix confs
 ## hostapd
 sudo sed 's|^DAEMON_CONF=$|&/etc/hostapd/hostapd.conf|' -i /etc/init.d/hostapd
 
+## nginx
+sudo sed "s|<TPL:NGINX_LOCATION>|${url_path}|g" -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
+sudo sed 's|<TPL:NGINX_REALPATH>|/var/www/wifiadmin/|g' -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
+sudo sed 's|<TPL:PHP_NAME>|wifiadmin|g' -i "/etc/nginx/conf.d/${domain}.d/wifiadmin.conf"
+
+## php-fpm
+sudo sed 's|<TPL:PHP_NAME>|wifiadmin|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
+sudo sed 's|<TPL:PHP_USER>|admin|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
+sudo sed 's|<TPL:PHP_GROUP>|admins|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
+sudo sed 's|<TPL:NGINX_REALPATH>|/var/www/wifiadmin/|g' -i /etc/php5/fpm/pool.d/wifiadmin.conf
+sudo sed 's|^;\?\s*max_execution_time.\+|max_execution_time = 600|' -i /etc/php5/fpm/php.ini
+
+# Fix sources
+sudo sed "s|<TPL:NGINX_LOCATION>|${url_path}|g" -i /var/www/wifiadmin/config.php
+
+# Copy init script
+sudo install -b -o root -g root -m 0755 ../conf/init_ynh-hotspot /etc/init.d/ynh-hotspot
+
 # Set default inits
 # The boot order of these services are important, so they are disabled by default
 # and the ynh-hotspot service handles them.
@@ -58,22 +95,33 @@ sudo sed 's|^DAEMON_CONF=$|&/etc/hostapd/hostapd.conf|' -i /etc/init.d/hostapd
 sudo yunohost service add isc-dhcp-server
 sudo yunohost service stop isc-dhcp-server
 sudo yunohost service disable isc-dhcp-server
+
 sudo yunohost service add radvd
 sudo yunohost service stop radvd
 sudo yunohost service disable radvd
+
 sudo yunohost service add hostapd 
 sudo yunohost service stop hostapd 
 sudo yunohost service disable hostapd 
 
+sudo yunohost service add php5-fpm
+sudo yunohost service enable php5-fpm
+sudo yunohost service stop php5-fpm
+sudo yunohost service start php5-fpm
+
+sudo service nginx reload
+
 # Remove IPv6 address set if there is a VPN installed
 sudo ip -6 address show dev tun0 2> /dev/null | grep -q "${ip6_addr}/"
 if [ "$?" -eq 0 ]; then
   sudo ip address delete "${ip6_addr}/128" dev tun0 &> /dev/null
 fi
 
-# Gooo
 sudo yunohost service add ynh-hotspot
 sudo yunohost service enable ynh-hotspot
-sudo yunohost service start ynh-hotspot
+sudo service ynh-hotspot start
+
+# Update SSO for wifiadmin
+sudo yunohost app ssowatconf
 
 exit 0

+ 18 - 2
scripts/remove

@@ -1,18 +1,34 @@
 #!/bin/bash
 
+# Retrieve arguments
+domain=$(sudo yunohost app setting hotspot domain)
+
 # The End
-sudo yunohost service stop ynh-hotspot
+sudo service ynh-hotspot stop
 sudo yunohost service remove ynh-hotspot
 sudo rm -f /etc/init.d/ynh-hotspot
 
 # Remove confs
 sudo rm -f /etc/hostapd/hostapd.conf{.tpl,} /etc/radvd.conf{.tpl,} /etc/dhcp/dhcpd.conf{.tpl,}
+sudo rm -f /etc/nginx/conf.d/${domain}.d/wifiadmin.conf
+sudo rm -f /etc/php5/fpm/pool.d/wifiadmin.conf
+
+# Restart services
+sudo yunohost service stop php5-fpm
+sudo yunohost service start php5-fpm
+sudo service nginx reload
+
+# Remove sources
+sudo rm -rf /var/www/wifiadmin/
+
+# Remove user
+sudo userdel -f wifiadmin
 
 # Restart vpnclient service if installed to set the IPv6 address
 # A new start will fix the address without unsetting all stuff
 sudo yunohost app list -f vpnclient --json | grep -q '"installed": true'
 if [ "$?" -eq 0 ]; then
-  sudo yunohost service start ynh-vpnclient
+  sudo service ynh-vpnclient start
 fi
 
 

+ 56 - 0
sources/config.php

@@ -0,0 +1,56 @@
+<?php
+
+// Limonade configuration
+function configure() {
+    option('env', ENV_PRODUCTION);
+    option('debug', false);
+    option('base_uri', '<TPL:NGINX_LOCATION>/');
+    layout("layout.html.php");
+    define('PUBLIC_DIR', '<TPL:NGINX_LOCATION>/public');
+}
+
+// Not found page
+function not_found($errno, $errstr, $errfile=null, $errline=null) {
+    $msg = h(rawurldecode($errstr));
+    return render($msg, 'error_layout.html.php');
+}
+
+function T_($string) {
+    return gettext($string);
+}
+
+// Before routing
+function before($route) {
+     /**
+     * * Locale
+     * */
+    if (!isset($_SESSION['locale'])) {
+        $locale = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
+        $_SESSION['locale'] = strtolower(substr(chop($locale[0]),0,2));
+    }
+    $textdomain="localization";
+    putenv('LANGUAGE='.$_SESSION['locale']);
+    putenv('LANG='.$_SESSION['locale']);
+    putenv('LC_ALL='.$_SESSION['locale']);
+    putenv('LC_MESSAGES='.$_SESSION['locale']);
+    setlocale(LC_ALL,$_SESSION['locale']);
+    setlocale(LC_CTYPE,$_SESSION['locale']);
+    $locales_dir = dirname(__FILE__).'/../i18n';
+    bindtextdomain($textdomain,$locales_dir);
+    bind_textdomain_codeset($textdomain, 'UTF-8');
+    textdomain($textdomain);
+    // Set the $locale variable in template
+    set('locale', $_SESSION['locale']);
+}
+
+// After routing
+function after($output, $route) {
+    /*
+    $time = number_format( (float)substr(microtime(), 0, 10) - LIM_START_MICROTIME, 6);
+    $output .= "\n<!-- page rendered in $time sec., on ".date(DATE_RFC822)." -->\n";
+    $output .= "<!-- for route\n";
+    $output .= print_r($route, true);
+    $output .= "-->";
+    */
+    return $output;
+}

+ 90 - 0
sources/controller.php

@@ -0,0 +1,90 @@
+<?php
+
+function moulinette_get($var) {
+  return htmlspecialchars(exec("sudo yunohost app setting hotspot ".escapeshellarg($var)));
+}
+
+function moulinette_set($var, $value) {
+  return exec("sudo yunohost app setting hotspot ".escapeshellarg($var)." -v ".escapeshellarg($value));
+}
+
+function restart_service() {
+  exec('sudo service ynh-hotspot stop');
+  exec('sudo service ynh-hotspot start', $output, $retcode);
+
+  return $retcode;
+}
+
+dispatch('/', function() {
+  set('title', T_('Wifi Hotspot'));
+
+  exec('ip link', $devs);
+  $wifi_device = moulinette_get('wifi_device');
+  $devs_list = "";
+
+  foreach($devs AS $dev) {
+    if(preg_match('/^[0-9]/', $dev)) {
+      $dev = explode(':', $dev);
+      $dev = trim($dev[1]);
+
+      if($dev != 'lo') {
+        $active = ($dev == $wifi_device) ? 'class="active"' : '';
+        $devs_list .= "<li $active><a href='#'>$dev</a></li>\n";
+      }
+    }
+  }
+
+  set('wifi_ssid', moulinette_get('wifi_ssid'));
+  set('wifi_passphrase', moulinette_get('wifi_passphrase'));
+  set('wifi_channel', moulinette_get('wifi_channel'));
+  set('wifi_device', $wifi_device);
+  set('wifi_device_list', $devs_list);
+  set('ip6_net', moulinette_get('ip6_net'));
+  set('ip6_dns0', moulinette_get('ip6_dns0'));
+  set('ip6_dns1', moulinette_get('ip6_dns1'));
+  set('ip4_nat_prefix', moulinette_get('ip4_nat_prefix'));
+  set('ip4_dns0', moulinette_get('ip4_dns0'));
+  set('ip4_dns1', moulinette_get('ip4_dns1'));
+
+  return render('settings.html.php');
+});
+
+dispatch_put('/settings', function() {
+  moulinette_set('wifi_ssid', $_POST['wifi_ssid']);
+  moulinette_set('wifi_passphrase', $_POST['wifi_passphrase']);
+  moulinette_set('wifi_channel', $_POST['wifi_channel']);
+  moulinette_set('wifi_device', $_POST['wifi_device']);
+  moulinette_set('ip6_net', $_POST['ip6_net']);
+  moulinette_set('ip6_dns0', $_POST['ip6_dns0']);
+  moulinette_set('ip6_dns1', $_POST['ip6_dns1']);
+  moulinette_set('ip4_nat_prefix', $_POST['ip4_nat_prefix']);
+  moulinette_set('ip4_dns0', $_POST['ip4_dns0']);
+  moulinette_set('ip4_dns1', $_POST['ip4_dns1']);
+
+  $retcode = restart_service();
+
+  if($retcode == 0) {
+    flash('success', T_('Configuration updated and service successfully reloaded'));
+  } else {
+    flash('error', T_('Configuration updated but service reload failed'));
+  }
+
+  redirect_to('/');
+});
+
+dispatch('/lang/:locale', function($locale = 'en') {
+  switch ($locale) {
+    case 'fr':
+      $_SESSION['locale'] = 'fr';
+      break;
+
+    default:
+      $_SESSION['locale'] = 'en';
+  }
+
+  if(!empty($_GET['redirect_to'])) {
+    redirect_to($_GET['redirect_to']);
+  } else {
+    redirect_to('/');
+  }
+});

+ 3 - 0
sources/i18n/README

@@ -0,0 +1,3 @@
+Add a "localization.pot" to this directory, and one folder per translated language, containing the po a LC_MESSAGE directory (with the .mo)
+
+See: https://github.com/YunoHost/admin_v1/tree/master/i18n

+ 11 - 0
sources/index.php

@@ -0,0 +1,11 @@
+<?php
+
+require dirname(__FILE__).'/lib/limonade.php';
+require dirname(__FILE__).'/controller.php';
+
+require dirname(__FILE__).'/lib/unix_func.php';
+//require '/usr/share/php/php-gettext/gettext.inc';
+
+require dirname(__FILE__).'/config.php';
+
+run();

Fichier diff supprimé car celui-ci est trop grand
+ 2707 - 0
sources/lib/limonade.php


+ 193 - 0
sources/lib/limonade/abstract.php

@@ -0,0 +1,193 @@
+<?php
+/**
+ * Abstract methods that might be redefined by user
+ * Do not include this file in your app: it only aims to provide documentation
+ * about those functions.
+ * 
+ * @package limonade
+ * @subpackage abstract
+ */
+ 
+/**
+ * It will be called when app is launched (at the begining of the run function).
+ * You can define options inside it, a connection to a database ...
+ *
+ * @abstract this function might be redefined by user
+ * @return void 
+ */
+function configure()
+{
+  return;
+}
+
+/**
+ * Called in run() just after session start, and before checking request method
+ * and output buffer start.  
+ *
+ * @abstract this function might be redefined by user
+ * @return void 
+ */
+function initialize()
+{
+  return;
+}
+
+/**
+ * Called in run() just after the route matching, in order to load controllers. 
+ * If not specfied, the default function is called:
+ * 
+ * <code>
+ * function autoload_controller($callback)
+ * {
+ *   require_once_dir(option('controllers_dir'));
+ * }
+ * </code>
+ * 
+ *
+ * @param string $callback the callback defined in matching route
+ * @return void
+ */
+function autoload_controller($callback)
+{
+  return;
+}
+ 
+/**
+ * Called before each request.
+ * This is very useful to define a default layout or passing common variables
+ * to the templates.
+ *
+ * @abstract this function might be redefined by user
+ * @param array() $route array (like returned by {@link route_build()},
+ *   with keys "method", "pattern", "names", "callback", "options")
+ * @return void 
+ */
+function before($route)
+{
+  
+}
+ 
+/**
+ * An `after` output filter
+ * 
+ * Called after each request and can apply a transformation to the output
+ * (except for `render_file` outputs  which are sent directly to the output buffer).
+ *
+ * @abstract this function might be redefined by user
+ * @param string $output 
+ * @param array() $route array (like returned by {@link route_find()},
+ *   with keys "method", "pattern", "names", "callback", "params", "options")
+ * @return string 
+ */
+function after($output, $route)
+{
+  # Call functions...
+  # .. modifies $output...
+  return $output;
+}
+ 
+/**
+ * Not found error output
+ *
+ * @abstract this function might be redefined by user
+ * @param string $errno 
+ * @param string $errstr 
+ * @param string $errfile 
+ * @param string $errline 
+ * @return string "not found" output string
+ */
+function not_found($errno, $errstr, $errfile=null, $errline=null)
+{
+ 
+}
+ 
+/**
+ * Server error output
+ *
+ * @abstract this function might be redefined by user
+ * @param string $errno 
+ * @param string $errstr 
+ * @param string $errfile 
+ * @param string $errline 
+ * @return string "server error" output string
+ */
+function server_error($errno, $errstr, $errfile=null, $errline=null)
+{
+  
+}
+ 
+/**
+ * Called when a route is not found.
+ * 
+ * 
+ * @abstract this function might be redefined by user
+ * @param string $request_method 
+ * @param string $request_uri 
+ * @return void 
+ */
+function route_missing($request_method, $request_uri)
+{
+  halt(NOT_FOUND, "($request_method) $request_uri"); # by default
+}
+
+/**
+ * Called before stoppping and exiting application.
+ *
+ * @abstract this function might be redefined by user
+ * @param boolean exit or not
+ * @return void 
+ */
+function before_exit($exit)
+{
+  
+}
+
+/**
+ * Rendering prefilter.
+ * Useful if you want to transform your views before rendering.
+ * The first three parameters are the same as those provided 
+ * to the `render` function.
+ *
+ * @abstract this function might be redefined by user
+ * @param string $content_or_func a function, a file in current views dir or a string
+ * @param string $layout 
+ * @param array $locals 
+ * @param array $view_path (by default <code>file_path(option('views_dir'),$content_or_func);</code>)
+ * @return array with, in order, $content_or_func, $layout, $locals vars
+ *  and the calculated $view_path
+ */
+function before_render($content_or_func, $layout, $locals, $view_path)
+{
+  # transform $content_or_func, $layout, $locals or $view_path…
+  return array($content_or_func, $layout, $locals, $view_path);
+}
+
+
+/**
+ * Called only if rendering $output is_null,
+ * like in a controller with no return statement.
+ *
+ * @abstract this function might be defined by user
+ * @param array() $route array (like returned by {@link route_build()},
+ *   with keys "method", "pattern", "names", "callback", "options")
+ * @return string
+ */
+function autorender($route)
+{
+  # process output depending on $route
+  return $output;
+}
+
+/**
+ * Called if a header is about to be sent
+ *
+ * @abstract this function might be defined by user
+ * @param string the headers that limonade will send
+ * @return void
+ */
+function before_sending_header($header)
+{
+
+}
+
+

+ 173 - 0
sources/lib/limonade/assertions.php

@@ -0,0 +1,173 @@
+<?php
+/**
+ * @package tests
+ * @subpackage assertions
+ */
+# ============================================================================ #
+#    ASSERTIONS                                                                #
+# ============================================================================ #
+
+/**
+ * assert_true
+ *
+ * @param string $value 
+ * @param string $message 
+ * @return boolean
+ */
+function assert_true($value, $message = '<1> should be TRUE')
+{
+   test_run_assertion();
+   return assert('$value === TRUE; //'.$message);
+}
+
+function assert_false($value, $message = '<1> should be FALSE')
+{
+   test_run_assertion();
+   return assert('$value === FALSE; //'.$message);
+}
+
+function assert_null($value, $message = '<1> should be NULL')
+{
+   test_run_assertion();
+   return assert('$value === NULL; //'.$message);
+}
+
+function assert_not_null($value, $message = '<1> should not be NULL')
+{
+   test_run_assertion();
+   return assert('$value !== NULL; //'.$message);
+}
+
+function assert_empty($value, $message = '<1> should be empty')
+{
+   test_run_assertion();
+   return assert('empty($value); //'.$message);
+}
+
+function assert_not_empty($value, $message = '<1> should not be empty')
+{
+   test_run_assertion();
+   return assert('!empty($value); //'.$message);
+}
+
+function assert_equal($expected, $value, $message = '<1> should be equal to <2>')
+{
+   test_run_assertion();
+   return assert('$expected == $value; //'.$message);
+}
+
+function assert_not_equal($expected, $value, $message = '<1> should not equal to <2>')
+{
+   test_run_assertion();
+   return assert('$expected != $value; //'.$message);
+}
+
+function assert_identical($expected, $value, $message = '<1> should be identical to <2>')
+{
+   test_run_assertion();
+   return assert('$expected === $value; //'.$message);
+}
+
+function assert_not_identical($expected, $value, $message = '<1> should not be identical to <2>')
+{
+   test_run_assertion();
+   return assert('$expected !== $value; //'.$message);
+}
+
+function assert_match($pattern, $string, $message = '<2> expected to match regular expression <1>') {
+   test_run_assertion();
+   return assert('preg_match($pattern, $string); //'.$message);
+}
+ 
+function assert_no_match($pattern, $string, $message = '<2> expected to not match regular expression <1>') {
+   test_run_assertion();
+   return assert('!preg_match($pattern, $string); //'.$message);
+}
+
+function assert_type($type, $value, $message = '<1> is not of type <2>') {
+  test_run_assertion();
+  $predicate = 'is_' . strtolower(is_string($type) ? $type : gettype($type));
+  return assert('$predicate($value); //'.$message);
+}
+ 
+function assert_instance_of($class, $object, $message = '<2> is not an instance of class <1>') {
+   test_run_assertion();
+   return assert('$object instanceof $class; //'.$message);
+}
+ 
+function assert_length_of($value, $length, $message = '<1> expected to be of length <2>') {
+   test_run_assertion();
+   $count = is_string($value) ? 'strlen' : 'count';
+   return assert('$count($value) == $length; //'.$message);
+}
+
+function assert_trigger_error($callable, $args = array(), $message = '<1> should trigger an error') {
+  test_run_assertion();
+  $trigger_errors = count($GLOBALS["limonade"]["test_errors"]);
+  set_error_handler("test_error_handler");
+  $result = call_user_func_array($callable, $args);
+  restore_error_handler();
+  return assert('$trigger_errors < count($GLOBALS["limonade"]["test_errors"]); //'.$message);
+}
+
+# TODO add web browser assertions assert_http_get, assert_http_response... as in SimpleTest (http://www.simpletest.org/en/web_tester_documentation.html)
+
+function assert_header($response, $expected_name, $expected_value = null, $message = "expected header '%s' to be equal to '%s' but received '%s: %s'")
+{
+  test_run_assertion();
+  # see assert_header in http://github.com/fnando/voodoo-test/blob/f3b0994ef138a6ba94d5e7cef6c1fb1720797a86/lib/assertions.php
+  $headers = preg_split("/^\s*$/ms", $response);
+  //var_dump($headers);    
+  $headers = preg_replace("/\s*$/sm", "", $headers[0]);
+  //var_dump($headers);   
+  
+  $regex_header = str_replace("/", "\\/", $expected_name);
+  $regex_header = str_replace(".", "\\.", $regex_header);
+  
+  $header = $expected_name;
+  
+  # from http://www.faqs.org/rfcs/rfc2616
+  # Field names are case-insensitive
+  if ($expected_value) {
+      $regex = "/^{$regex_header}:(.*?)$/ism";
+      $header .= ": {$expected_value}";
+  } else {
+      $regex = "/^{$regex_header}(:.*?)?$/ism";
+  }
+  
+  $has_header = preg_match($regex, $headers, $matches);    
+  $sent_header = trim((string)$matches[1]);
+
+  
+  if(empty($sent_header))
+  {
+    if(is_null($expected_value))
+    {
+      $message = "expected header '%s' but header has not been sent";
+    }
+    else
+    {
+      $message = "expected header '%s' to be equal to '%s' but header has not been sent";
+    }
+    
+    $message = sprintf($message, $expected_name, $expected_value);
+    return assert("false; //".$message);
+  }
+  else if($expected_value)
+  {
+    $message = sprintf($message, $expected_name, $expected_value, $expected_name, $sent_header);
+    return assert('$expected_value && $sent_header == $expected_value; //'.$message);
+  }
+  return assert("true; //");
+}
+
+function assert_status($response, $expected_status, $message = "expected status code to be equal to '%s' but received '%s'")
+{
+  $lines = explode('\n', trim($response));
+  if (preg_match('/HTTP\/(\d+\.\d+)\s+(\d+)/i', $lines[0], $matches))
+  {
+      $status = $matches[2];
+      return assert('$expected_status == $status; //'.sprintf($message, $expected_status, $status));
+  }
+  return assert("false; //no status code returned in this response string");
+}

+ 220 - 0
sources/lib/limonade/public/css/screen.css

@@ -0,0 +1,220 @@
+/* -----------------------------------------------------------------------
+
+
+ Blueprint CSS Framework 0.8
+ http://blueprintcss.org
+
+   * Copyright (c) 2007-Present. See LICENSE for more info.
+   * See README for instructions on how to use Blueprint.
+   * For credits and origins, see AUTHORS.
+   * This is a compressed file. See the sources in the 'src' directory.
+
+----------------------------------------------------------------------- */
+
+/* reset.css */
+html, body, div, span, object, iframe, h1, h2, h3, h4, h5, h6, p, blockquote, pre, a, abbr, acronym, address, code, del, dfn, em, img, q, dl, dt, dd, ol, ul, li, fieldset, form, label, legend, table, caption, tbody, tfoot, thead, tr, th, td {margin:0;padding:0;border:0;font-weight:inherit;font-style:inherit;font-size:100%;font-family:inherit;vertical-align:baseline;}
+body {line-height:1.5;}
+table {border-collapse:separate;border-spacing:0;}
+caption, th, td {text-align:left;font-weight:normal;}
+table, td, th {vertical-align:middle;}
+blockquote:before, blockquote:after, q:before, q:after {content:"";}
+blockquote, q {quotes:"" "";}
+a img {border:none;}
+
+/* typography.css */
+body {font-size:75%;color:#222;background:#fff;font-family:"Helvetica Neue", Arial, Helvetica, sans-serif;}
+h1, h2, h3, h4, h5, h6 {font-weight:normal;color:#111;}
+h1 {font-size:3em;line-height:1;margin-bottom:0.5em;}
+h2 {font-size:2em;margin-bottom:0.75em;}
+h3 {font-size:1.5em;line-height:1;margin-bottom:1em;}
+h4 {font-size:1.2em;line-height:1.25;margin-bottom:1.25em;}
+h5 {font-size:1em;font-weight:bold;margin-bottom:1.5em;}
+h6 {font-size:1em;font-weight:bold;}
+h1 img, h2 img, h3 img, h4 img, h5 img, h6 img {margin:0;}
+p {margin:0 0 1.5em;}
+p img.left {float:left;margin:1.5em 1.5em 1.5em 0;padding:0;}
+p img.right {float:right;margin:1.5em 0 1.5em 1.5em;}
+a:focus, a:hover {color:#000;}
+a {color:#009;text-decoration:underline;}
+blockquote {margin:1.5em;color:#666;font-style:italic;}
+strong {font-weight:bold;}
+em, dfn {font-style:italic;}
+dfn {font-weight:bold;}
+sup, sub {line-height:0;}
+abbr, acronym {border-bottom:1px dotted #666;}
+address {margin:0 0 1.5em;font-style:italic;}
+del {color:#666;}
+pre {margin:1.5em 0;white-space:pre;}
+pre, code, tt {font:1em 'andale mono', 'lucida console', monospace;line-height:1.5;}
+li ul, li ol {margin:0 1.5em;}
+ul, ol {margin:0 1.5em 1.5em 1.5em;}
+ul {list-style-type:disc;}
+ol {list-style-type:decimal;}
+dl {margin:0 0 1.5em 0;}
+dl dt {font-weight:bold;}
+dd {margin-left:1.5em;}
+table {margin-bottom:1.4em;width:100%;}
+th {font-weight:bold;}
+thead th {background:#c3d9ff;}
+th, td, caption {padding:4px 10px 4px 5px;}
+tr.even td {background:#e5ecf9;}
+tfoot {font-style:italic;}
+caption {background:#eee;}
+.small {font-size:.8em;margin-bottom:1.875em;line-height:1.875em;}
+.large {font-size:1.2em;line-height:2.5em;margin-bottom:1.25em;}
+.hide {display:none;}
+.quiet {color:#666;}
+.loud {color:#000;}
+.highlight {background:#ff0;}
+.added {background:#060;color:#fff;}
+.removed {background:#900;color:#fff;}
+.first {margin-left:0;padding-left:0;}
+.last {margin-right:0;padding-right:0;}
+.top {margin-top:0;padding-top:0;}
+.bottom {margin-bottom:0;padding-bottom:0;}
+
+/* forms.css */
+label {font-weight:bold;}
+fieldset {padding:1.4em;margin:0 0 1.5em 0;border:1px solid #ccc;}
+legend {font-weight:bold;font-size:1.2em;}
+input.text, input.title, textarea, select {margin:0.5em 0;border:1px solid #bbb;}
+input.text:focus, input.title:focus, textarea:focus, select:focus {border:1px solid #666;}
+input.text, input.title {width:300px;padding:5px;}
+input.title {font-size:1.5em;}
+textarea {width:390px;height:250px;padding:5px;}
+.error, .notice, .success {padding:.8em;margin-bottom:1em;border:2px solid #ddd;}
+.error {background:#FBE3E4;color:#8a1f11;border-color:#FBC2C4;}
+.notice {background:#FFF6BF;color:#514721;border-color:#FFD324;}
+.success {background:#E6EFC2;color:#264409;border-color:#C6D880;}
+.error a {color:#8a1f11;}
+.notice a {color:#514721;}
+.success a {color:#264409;}
+
+.box {padding:1.5em;margin-bottom:1.5em;background:#E5ECF9;}
+hr {background:#ddd;color:#ddd;clear:both;float:none;width:100%;height:.1em;margin:0 0 1.45em;border:none;}
+hr.space {background:#fff;color:#fff;}
+.clearfix:after, .container:after {content:"\0020";display:block;height:0;clear:both;visibility:hidden;overflow:hidden;}
+.clearfix, .container {display:block;}
+.clear {clear:both;}
+
+/* -----------------------------------------------------------------------
+
+ LIMONADE
+ 
+ Design and logo by <a href="http://www.minimau.com">Minimau</a>
+
+----------------------------------------------------------------------- */
+
+html {
+ 	background-color: #b4a689;
+ 	text-align: center;
+ 	}
+ 	body {
+ 		width: auto; /* 16 col */
+ 		margin: 0 20px;
+ 		text-align: left;
+ 		/*background: #fff url(blueprint/src/grid.png);*/
+ 		font-family: Verdana, Geneva, sans-serif;
+ 		color: #303030;
+ 		}
+ 		a, a:hover, a:visited {
+ 			color: #4596cd;
+ 			}
+ 		a:hover {
+ 			text-decoration: none;
+ 			}
+ 		#header, h1, h2, h3, h4 {
+ 			font-family: "Arial Black", Gadget, sans-serif;
+ 			}
+ 		h1 {
+ 			color: #b4a689;
+ 			font-size: 2em;
+ 			line-height: 2;
+ 			border-bottom: 7px solid #000;
+ 			margin-bottom: 0.75em;
+ 			margin-top:0;
+ 			}
+ 		h2 {
+ 			font-size: 1.5em;
+ 			color: #cddb12;
+ 			margin-top: 2em;
+ 			line-height: 0.8;
+ 			margin-bottom: 1.2em;
+ 			}
+ 		h3 {
+ 			font-size: 1.33em;
+ 			line-height: 0.89;
+ 			margin-top: 2.66em;
+ 			margin-bottom: 1.33em;
+ 			color:#95b383;
+ 			}
+ 		pre {
+ 			background-color: #cddb12;
+ 			font-size: 12px;
+ 			padding: 1.5em;
+ 			margin-bottom: 1.5em;
+ 			overflow: auto;
+ 			}
+ 		code {
+ 			font: 10px Monaco, "Courier New", Courier, monospace;
+ 			color: #0d562a;
+ 			}
+ 		#header {
+ 			/*position:relative;*/
+ 			height: 187px; /* 12 lines */
+ 			background: #fff url(<?=url_for('/_lim_public/img/bg_header.png')?>) no-repeat 0 0;
+ 			margin-top: 10px;
+      padding:0;
+ 			}
+ 			#header h1 {
+ 				position: absolute;
+ 				left:-9999px;
+ 				   			margin:0;
+ 				}
+ 		#footer {
+ 			padding: 0 55px;
+ 			background-color: #1a1818;
+ 			color: #999;
+ 			height: 2em;
+ 			line-height: 2em;
+ 			text-align: right;
+ 			}
+ 			#footer a {
+ 				color: #a3d8de;
+ 				text-decoration: none;
+ 				}
+ 			#footer a:hover {
+ 				color: #fff;
+ 				}
+ 		#content {
+ 		  background-color: #fff;
+ 			padding: 0 55px;
+ 			min-height: 400px;
+ 			}
+    		p.bt {
+    		   text-align:right;
+    		   }
+       		p.bt a {
+       		   text-decoration:none;
+       		   padding: 2px 4px;
+       		   }
+       		p.bt a:hover {
+      	      background-color: #4596cd;
+      	      color: #fff;
+      	      }
+      	#debug-menu {
+      	   position: fixed;
+      	   top: 0px;
+      	   right:20px;
+      	   background-color: rgba(100,100,100, 0.7);
+      	   padding:5px;
+      	}
+      	#debug-menu a {
+      	   color: #fff;
+      	   font-size: 90%;
+      	   text-decoration:none;
+   	   }
+   	   #debug-menu a:hover {
+   	      text-decoration: underline;
+	      }
+   	

BIN
sources/lib/limonade/public/img/bg_header.png


+ 350 - 0
sources/lib/limonade/tests.php

@@ -0,0 +1,350 @@
+<?php
+/**
+ * @package tests
+ */
+ 
+# ============================================================================ #
+#    TESTS                                                                     #
+# ============================================================================ #
+
+/**
+ * load assertions
+ */
+require_once dirname(__FILE__)."/assertions.php";
+
+
+ 
+/**
+ * Constants and globals
+ */
+if(!defined('DS')) define("DS", DIRECTORY_SEPARATOR);
+
+if(!array_key_exists("limonade", $GLOBALS))
+   $GLOBALS["limonade"] = array();
+if(!array_key_exists("test_cases", $GLOBALS["limonade"]))
+   $GLOBALS["limonade"]["test_cases"] = array();
+if(!array_key_exists("test_errors", $GLOBALS["limonade"]))
+   $GLOBALS["limonade"]["test_errors"] = array();
+if(!array_key_exists("test_case_current", $GLOBALS["limonade"]))
+   $GLOBALS["limonade"]["test_case_current"] = NULL;
+if(!array_key_exists("test_suites", $GLOBALS["limonade"]))
+   $GLOBALS["limonade"]["test_suites"] = NULL;
+
+ini_set("display_errors", true);
+error_reporting(E_ALL ^ (E_USER_WARNING | E_NOTICE | E_USER_NOTICE));
+// error_reporting(E_ALL | E_STRICT);
+assert_options(ASSERT_ACTIVE, 1);
+assert_options(ASSERT_WARNING, 0);
+assert_options(ASSERT_BAIL, 0);
+assert_options(ASSERT_QUIET_EVAL, 0);
+assert_options(ASSERT_CALLBACK, 'test_assert_failure');
+
+# TODO: separate display from logic
+# TODO: clean results output
+# TODO: add all tests results
+
+/**
+ * Starts a test suite
+ *
+ * @param string $name 
+ * @return void
+ */
+function test_suite($name)
+{
+  $GLOBALS["limonade"]["test_suites"] = $name;
+  echo test_cli_format("===========================================================\n", 'white');
+  echo test_cli_format(">>>> START $name tests suites\n", 'white');
+  echo test_cli_format("-----------------------------------------------------------\n", 'white');
+}
+
+/**
+ * Ends the last group of test suites
+ *
+ * @return void
+ */
+function end_test_suite()
+{
+  $name         = $GLOBALS["limonade"]["test_suites"];
+  $failures     = 0;
+  $tests        = 0;
+  $passed_tests = 0;
+  $assertions   = 0;
+
+  foreach($GLOBALS["limonade"]["test_cases"] as $test)
+  {
+    $failures += $test['failures'];
+    $assertions += $test['assertions'];
+    if(empty($test['failures'])) $passed_tests++;
+    $tests++;
+  }
+  echo ">> ENDING $name tests suites\n  ";
+  echo $failures > 0 ? test_cli_format("|FAILED!|", "red") : test_cli_format("|PASSED|", "green");;
+  echo " Passes ".$passed_tests."/".$tests.", ";
+  echo " {$failures} failures for {$assertions} assertions.\n";
+  echo test_cli_format("===========================================================\n", 'white');
+}
+
+/**
+ * Starting a new test case
+ *
+ * @param string $name 
+ * @return void
+ */
+function test_case($name)
+{
+   $name = strtolower($name); // TODO: normalize name
+   
+   if(!array_key_exists($name, $GLOBALS["limonade"]["test_cases"]))
+   {
+      $GLOBALS["limonade"]["test_cases"][$name] = array( 
+                                                      "name" => $name,
+                                                      "assertions" => 0, 
+                                                      "failures" => 0,
+                                                      "description" => NULL
+                                                   );      
+      $GLOBALS["limonade"]["test_case_current"] = $name;
+   }
+   else
+   {
+      
+   }
+}
+
+/**
+ * Displays and ending the current tests suite
+ * 
+ * @return void
+ */
+function end_test_case()
+{
+   $name = $GLOBALS["limonade"]["test_case_current"];
+   echo "## ".strtoupper($name)."\n";
+      
+   $desc = test_case_describe();
+   if(!is_null($desc)) echo $desc."\n";
+
+   echo "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n";
+   
+   test_case_execute_current();
+   
+   
+   if(!is_null($name))
+   {
+      $test = $GLOBALS["limonade"]["test_cases"][$name];
+      // closing previous test
+      echo "\n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n";
+      echo $test['failures'] > 0 ? test_cli_format("|FAILED!|", "red") : test_cli_format("|PASSED|", "green");
+      echo " Test case '$name' finished: ";
+      echo count(test_case_all_func())." tests, ";
+      echo " {$test['failures']} failures for {$test['assertions']} assertions.\n";
+      
+      echo "-----------------------------------------------------------\n";
+   }
+   $GLOBALS["limonade"]["test_case_current"] = null;
+}
+
+/**
+ * Describes the current tests suite
+ *
+ * @param string $msg 
+ * @return string tests description
+ */
+function test_case_describe($msg = NULL)
+{
+   $test =& test_case_current();
+   if(!is_null($msg))
+   {
+      $test["description"] = $msg;
+   }
+   //var_dump($test["description"]);
+   return $test["description"];
+}
+
+/**
+ * Returns all user test case functions
+ *
+ * @access private
+ * @return void
+ */
+function test_case_all_func()
+{
+   $functions = get_defined_functions();
+   $functions = $functions['user'];
+   $tests = array();
+   $name = $GLOBALS["limonade"]["test_case_current"];
+   while ($func = array_shift($functions)) {
+      $regexp = "/^test_{$name}_(.*)$/";
+      if(!preg_match($regexp, $func)) continue;
+      if($func == test_before_func_name()) continue;
+      // TODO: adding break for all test api methods
+      
+      $tests[] = $func;
+   }
+   return $tests;
+}
+
+/**
+ * Execute current test case
+ *
+ * @access private
+ * @return void
+ */
+function test_case_execute_current()
+{
+   $tests = test_case_all_func();
+   while($func = array_shift($tests))
+   {
+      test_call_func(test_before_func_name());
+      call_user_func($func);
+   }
+}
+
+
+function &test_case_current()
+{
+   $name = $GLOBALS["limonade"]["test_case_current"];
+   return $GLOBALS["limonade"]["test_cases"][$name];
+}
+
+
+
+function test_before_func_name()
+{
+   $test = test_case_current();
+   $func = "before_each_test_in_".$test["name"];
+   return $func;
+}
+
+function test_before_assert_func_name()
+{
+   $test = test_case_current();
+   $func = "before_each_assert_in_$name".$test["name"];
+   return $func;
+}
+
+function test_run_assertion()
+{
+   $name = $GLOBALS["limonade"]["test_case_current"];
+   $GLOBALS["limonade"]["test_cases"][$name]['assertions']++;
+   test_call_func(test_before_assert_func_name());
+}
+
+/**
+ * Calls a function if exists
+ *
+ * @param string $func the function name
+ * @param mixed $arg,.. (optional)
+ * @return mixed
+ */
+function test_call_func($func)
+{
+  if(empty($func)) return;
+  $args = func_get_args();
+  $func = array_shift($args);
+  if(function_exists($func)) return call_user_func_array($func, $args);
+  return;
+}
+
+/**
+ * Error handler 
+ * 
+ * @access private
+ * @return boolean true
+ */
+function test_error_handler($errno, $errstr, $errfile, $errline)
+{
+	if($errno < E_USER_ERROR || $errno > E_USER_NOTICE) 
+	   echo test_cli_format("!!! ERROR", "red") . " [$errno], $errstr in $errfile at line $errline\n";
+	$GLOBALS["limonade"]["test_errors"][] = array($errno, $errstr, $errfile, $errline);
+   return true;
+}
+
+/**
+ * Assert callback
+ * 
+ * @access private
+ * @param string $script 
+ * @param string $line 
+ * @param string $message 
+ * @return void
+ */
+function test_assert_failure($script, $line, $message)
+{
+   // Using the stack trace, find the outermost assert*() call
+   $stacktrace = array_slice(debug_backtrace(), 1); // skip self
+   $assertion = reset($stacktrace);
+   while ($stackframe = array_shift($stacktrace)) {
+    if (!preg_match('/^assert/', $stackframe['function']))
+      break;
+    $assertion = $stackframe;
+   }
+
+   extract($assertion, EXTR_PREFIX_ALL, 'assert');
+   $code = explode("\n", file_get_contents($assert_file));
+   $code = trim($code[$assert_line - 1]);
+   
+   list($assert_code, $message) = explode("//", $message);
+   echo test_cli_format("Assertion failed", "yellow");
+   echo " in script *{$assert_file}* (line {$assert_line}):\n";
+   echo "   * assertion: $code\n";
+   echo "   * message:   $message\n";
+   $name = $GLOBALS["limonade"]["test_case_current"];
+   $GLOBALS["limonade"]["test_cases"][$name]['failures']++;
+}
+
+function test_cli_format($text, $format) {
+    $formats = array(
+        "blue"       => 34,
+        "bold"       => 1,
+        "green"      => 32,
+        "highlight"  => 7,
+        "light_blue" => 36,
+        "purple"     => 35,
+        "red"        => 31,
+        "underline"  => 4,
+        "white"      => 37,
+        "yellow"     => 33
+    );
+
+    if (array_key_exists($format, $formats)) $format = $formats[$format];
+    return chr(27) . "[01;{$format} m{$text}" . chr(27) . "[00m";
+}
+
+/**
+ * Do HTTP request and return the response content.
+ * 
+ * @param string $url
+ * @param string $method
+ * @param bool $include_header
+ * @return string
+ * @author Nando Vieira
+ */
+function test_request($url, $method="GET", $include_header=false, $post_data=array(), $http_header=array()) {
+    $method = strtoupper($method);
+    $allowed_methods = array("GET", "PUT", "POST", "DELETE", "HEAD");
+    if(!in_array($method, $allowed_methods))
+    {
+      $message = "The requested method '$method' is not allowed";
+      return assert('false; //'.$message);
+    }
+    
+    $curl = curl_init($url);
+    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
+    curl_setopt($curl, CURLOPT_HEADER, $include_header);
+    curl_setopt($curl, CURLOPT_HTTPHEADER, $http_header);
+    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);
+    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1); 
+    if($method == 'POST' || $method == 'PUT')
+    {
+      curl_setopt($curl, CURLOPT_POST, 1);
+      curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
+    }
+    if($method == 'HEAD')
+    {
+      curl_setopt($curl, CURLOPT_NOBODY, true);
+    }
+    $response = curl_exec($curl);
+    curl_close($curl);
+
+    return $response;
+}

+ 37 - 0
sources/lib/limonade/views/_debug.html.php

@@ -0,0 +1,37 @@
+<?php if(option('env') > ENV_PRODUCTION && option('debug')): ?>
+  <?php if(!$is_http_error): ?>
+  <p>[<?php echo error_type($errno)?>]
+  	<?php echo $errstr?> (in <strong><?php echo $errfile?></strong> line <strong><?php echo $errline?></strong>)
+  	</p>
+  	<?php endif; ?>
+
+
+  <?php if($debug_args = set('_lim_err_debug_args')): ?>
+  <h2 id="debug-arguments">Debug arguments</h2>
+  	<pre><code><?php echo h(print_r($debug_args, true))?></code></pre>
+  <?php endif; ?>
+  
+  <h2 id="limonade-options">Options</strong></h2>
+  <pre><code><?php echo h(print_r(option(), true))?></code></pre>
+  <p class="bt top"><a href="#header">[ &#x2191; ]</a></p>
+  
+  <h2 id="environment">Environment</h2>
+  <pre><code><?php echo h(print_r(env(), true))?></code></pre>
+  <p class="bt top"><a href="#header">[ &#x2191; ]</a></p>
+  
+  <h2 id="debug-backtrace">Backtrace</h2>
+  <pre><code><?php echo h(print_r(debug_backtrace(), true))?></code></pre>
+  <p class="bt top"><a href="#header">[ &#x2191; ]</a></p>
+
+  <div id="debug-menu">
+    
+    <?php if($debug_args = set('_lim_err_debug_args')): ?>
+    <a href="#debug-arguments">Debug arguments</a> |
+    <?php endif; ?>
+    <a href="#limonade-options">Options</a> |
+    <a href="#environment">Environment</a> |
+    <a href="#debug-backtrace">Backtrace</a> |
+    <a href="#header">[ &#x2191; ]</a>
+  </div>
+  
+<?php endif; ?>

+ 15 - 0
sources/lib/limonade/views/_notices.html.php

@@ -0,0 +1,15 @@
+<?php if(!empty($notices)): ?>
+<div class="lim-debug lim-notices">
+  <h4> &#x2192; Notices and warnings</h4>
+  <dl>
+  <?php $cpt = 1; foreach($notices as $notice): ?>
+    <dt>[<?php echo $cpt.'. '.error_type($notice['errno'])?>]</dt>
+    <dd>
+    <?php echo $notice['errstr']?> in <strong><code><?php echo $notice['errfile']?></code></strong> 
+    line <strong><code><?php echo $notice['errline']?></code></strong>
+    </dd>
+  <?php $cpt++; endforeach; ?>
+  </dl>
+  <hr>
+</div>
+<?php endif; ?>

+ 22 - 0
sources/lib/limonade/views/default_layout.php

@@ -0,0 +1,22 @@
+<!DOCTYPE html>
+<html>
+<head>
+	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+	<title>Limonade, the fizzy PHP micro-framework</title>
+	<link rel="stylesheet" href="<?php echo url_for('/_lim_css/screen.css');?>" type="text/css" media="screen">
+</head>
+<body>
+  <div id="header">
+    <h1>Limonade</h1>
+  </div>
+  
+  <div id="content">
+    <?php echo error_notices_render(); ?>
+    <div id="main">
+      <?php echo $content;?>
+      <hr class="space">
+    </div>
+  </div>
+
+</body>
+</html>

+ 6 - 0
sources/lib/limonade/views/error.html.php

@@ -0,0 +1,6 @@
+  <h1><?php echo h(error_http_status($errno));?></h1>
+  <?php if($is_http_error): ?>
+  <p><?php echo h($errstr)?></p>
+  <?php endif; ?>
+  
+  <?php echo  render('_debug.html.php', null, $vars); ?>

+ 49 - 0
sources/lib/unix_func.php

@@ -0,0 +1,49 @@
+<?php 
+
+ /**
+  *  YunoHost - Self-hosting for all
+  *  Copyright (C) 2012  Kload <kload@kload.fr>
+  *
+  *  This program is free software: you can redistribute it and/or modify
+  *  it under the terms of the GNU Affero General Public License as
+  *  published by the Free Software Foundation, either version 3 of the
+  *  License, or (at your option) any later version.
+  *
+  *  This program is distributed in the hope that it will be useful,
+  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  *  GNU Affero General Public License for more details.
+  *
+  *  You should have received a copy of the GNU Affero General Public License
+  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+  */
+  
+function read_file($file, $lines = 20) {
+
+    if (!$handle = fopen($file, "r"))
+        return false;
+    $linecounter = $lines;
+    $pos = -2;
+    $beginning = false;
+    $text = array();
+    while ($linecounter > 0) {
+        $t = " ";
+        while ($t != "\n") {
+            if(fseek($handle, $pos, SEEK_END) == -1) {
+                $beginning = true;
+                break;
+            }
+            $t = fgetc($handle);
+            $pos --;
+        }
+        $linecounter --;
+        if ($beginning) {
+            rewind($handle);
+        }
+        $text[$lines-$linecounter-1] = fgets($handle);
+        if ($beginning) break;
+    }
+    fclose ($handle);
+    return array_reverse($text);
+}
+

+ 457 - 0
sources/public/bootstrap/css/bootstrap-theme.css

@@ -0,0 +1,457 @@
+/*!
+ * Bootstrap v3.3.0 (http://getbootstrap.com)
+ * Copyright 2011-2014 Twitter, Inc.
+ * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
+ */
+
+.btn-default,
+.btn-primary,
+.btn-success,
+.btn-info,
+.btn-warning,
+.btn-danger {
+  text-shadow: 0 -1px 0 rgba(0, 0, 0, .2);
+  -webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, .15), 0 1px 1px rgba(0, 0, 0, .075);
+          box-shadow: inset 0 1px 0 rgba(255, 255, 255, .15), 0 1px 1px rgba(0, 0, 0, .075);
+}
+.btn-default:active,
+.btn-primary:active,
+.btn-success:active,
+.btn-info:active,
+.btn-warning:active,
+.btn-danger:active,
+.btn-default.active,
+.btn-primary.active,
+.btn-success.active,
+.btn-info.active,
+.btn-warning.active,
+.btn-danger.active {
+  -webkit-box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);
+          box-shadow: inset 0 3px 5px rgba(0, 0, 0, .125);
+}
+.btn-default .badge,
+.btn-primary .badge,
+.btn-success .badge,
+.btn-info .badge,
+.btn-warning .badge,
+.btn-danger .badge {
+  text-shadow: none;
+}
+.btn:active,
+.btn.active {
+  background-image: none;
+}
+.btn-default {
+  text-shadow: 0 1px 0 #fff;
+  background-image: -webkit-linear-gradient(top, #fff 0%, #e0e0e0 100%);
+  background-image:      -o-linear-gradient(top, #fff 0%, #e0e0e0 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#fff), to(#e0e0e0));
+  background-image:         linear-gradient(to bottom, #fff 0%, #e0e0e0 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#ffe0e0e0', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #dbdbdb;
+  border-color: #ccc;
+}
+.btn-default:hover,
+.btn-default:focus {
+  background-color: #e0e0e0;
+  background-position: 0 -15px;
+}
+.btn-default:active,
+.btn-default.active {
+  background-color: #e0e0e0;
+  border-color: #dbdbdb;
+}
+.btn-default:disabled,
+.btn-default[disabled] {
+  background-color: #e0e0e0;
+  background-image: none;
+}
+.btn-primary {
+  background-image: -webkit-linear-gradient(top, #428bca 0%, #2d6ca2 100%);
+  background-image:      -o-linear-gradient(top, #428bca 0%, #2d6ca2 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#428bca), to(#2d6ca2));
+  background-image:         linear-gradient(to bottom, #428bca 0%, #2d6ca2 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff428bca', endColorstr='#ff2d6ca2', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #2b669a;
+}
+.btn-primary:hover,
+.btn-primary:focus {
+  background-color: #2d6ca2;
+  background-position: 0 -15px;
+}
+.btn-primary:active,
+.btn-primary.active {
+  background-color: #2d6ca2;
+  border-color: #2b669a;
+}
+.btn-primary:disabled,
+.btn-primary[disabled] {
+  background-color: #2d6ca2;
+  background-image: none;
+}
+.btn-success {
+  background-image: -webkit-linear-gradient(top, #5cb85c 0%, #419641 100%);
+  background-image:      -o-linear-gradient(top, #5cb85c 0%, #419641 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#5cb85c), to(#419641));
+  background-image:         linear-gradient(to bottom, #5cb85c 0%, #419641 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff5cb85c', endColorstr='#ff419641', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #3e8f3e;
+}
+.btn-success:hover,
+.btn-success:focus {
+  background-color: #419641;
+  background-position: 0 -15px;
+}
+.btn-success:active,
+.btn-success.active {
+  background-color: #419641;
+  border-color: #3e8f3e;
+}
+.btn-success:disabled,
+.btn-success[disabled] {
+  background-color: #419641;
+  background-image: none;
+}
+.btn-info {
+  background-image: -webkit-linear-gradient(top, #5bc0de 0%, #2aabd2 100%);
+  background-image:      -o-linear-gradient(top, #5bc0de 0%, #2aabd2 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#5bc0de), to(#2aabd2));
+  background-image:         linear-gradient(to bottom, #5bc0de 0%, #2aabd2 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff5bc0de', endColorstr='#ff2aabd2', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #28a4c9;
+}
+.btn-info:hover,
+.btn-info:focus {
+  background-color: #2aabd2;
+  background-position: 0 -15px;
+}
+.btn-info:active,
+.btn-info.active {
+  background-color: #2aabd2;
+  border-color: #28a4c9;
+}
+.btn-info:disabled,
+.btn-info[disabled] {
+  background-color: #2aabd2;
+  background-image: none;
+}
+.btn-warning {
+  background-image: -webkit-linear-gradient(top, #f0ad4e 0%, #eb9316 100%);
+  background-image:      -o-linear-gradient(top, #f0ad4e 0%, #eb9316 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f0ad4e), to(#eb9316));
+  background-image:         linear-gradient(to bottom, #f0ad4e 0%, #eb9316 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff0ad4e', endColorstr='#ffeb9316', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #e38d13;
+}
+.btn-warning:hover,
+.btn-warning:focus {
+  background-color: #eb9316;
+  background-position: 0 -15px;
+}
+.btn-warning:active,
+.btn-warning.active {
+  background-color: #eb9316;
+  border-color: #e38d13;
+}
+.btn-warning:disabled,
+.btn-warning[disabled] {
+  background-color: #eb9316;
+  background-image: none;
+}
+.btn-danger {
+  background-image: -webkit-linear-gradient(top, #d9534f 0%, #c12e2a 100%);
+  background-image:      -o-linear-gradient(top, #d9534f 0%, #c12e2a 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#d9534f), to(#c12e2a));
+  background-image:         linear-gradient(to bottom, #d9534f 0%, #c12e2a 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffd9534f', endColorstr='#ffc12e2a', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-color: #b92c28;
+}
+.btn-danger:hover,
+.btn-danger:focus {
+  background-color: #c12e2a;
+  background-position: 0 -15px;
+}
+.btn-danger:active,
+.btn-danger.active {
+  background-color: #c12e2a;
+  border-color: #b92c28;
+}
+.btn-danger:disabled,
+.btn-danger[disabled] {
+  background-color: #c12e2a;
+  background-image: none;
+}
+.thumbnail,
+.img-thumbnail {
+  -webkit-box-shadow: 0 1px 2px rgba(0, 0, 0, .075);
+          box-shadow: 0 1px 2px rgba(0, 0, 0, .075);
+}
+.dropdown-menu > li > a:hover,
+.dropdown-menu > li > a:focus {
+  background-color: #e8e8e8;
+  background-image: -webkit-linear-gradient(top, #f5f5f5 0%, #e8e8e8 100%);
+  background-image:      -o-linear-gradient(top, #f5f5f5 0%, #e8e8e8 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f5f5f5), to(#e8e8e8));
+  background-image:         linear-gradient(to bottom, #f5f5f5 0%, #e8e8e8 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff5f5f5', endColorstr='#ffe8e8e8', GradientType=0);
+  background-repeat: repeat-x;
+}
+.dropdown-menu > .active > a,
+.dropdown-menu > .active > a:hover,
+.dropdown-menu > .active > a:focus {
+  background-color: #357ebd;
+  background-image: -webkit-linear-gradient(top, #428bca 0%, #357ebd 100%);
+  background-image:      -o-linear-gradient(top, #428bca 0%, #357ebd 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#428bca), to(#357ebd));
+  background-image:         linear-gradient(to bottom, #428bca 0%, #357ebd 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff428bca', endColorstr='#ff357ebd', GradientType=0);
+  background-repeat: repeat-x;
+}
+.navbar-default {
+  background-image: -webkit-linear-gradient(top, #fff 0%, #f8f8f8 100%);
+  background-image:      -o-linear-gradient(top, #fff 0%, #f8f8f8 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#fff), to(#f8f8f8));
+  background-image:         linear-gradient(to bottom, #fff 0%, #f8f8f8 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#fff8f8f8', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+  border-radius: 4px;
+  -webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, .15), 0 1px 5px rgba(0, 0, 0, .075);
+          box-shadow: inset 0 1px 0 rgba(255, 255, 255, .15), 0 1px 5px rgba(0, 0, 0, .075);
+}
+.navbar-default .navbar-nav > .open > a,
+.navbar-default .navbar-nav > .active > a {
+  background-image: -webkit-linear-gradient(top, #dbdbdb 0%, #e2e2e2 100%);
+  background-image:      -o-linear-gradient(top, #dbdbdb 0%, #e2e2e2 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#dbdbdb), to(#e2e2e2));
+  background-image:         linear-gradient(to bottom, #dbdbdb 0%, #e2e2e2 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffdbdbdb', endColorstr='#ffe2e2e2', GradientType=0);
+  background-repeat: repeat-x;
+  -webkit-box-shadow: inset 0 3px 9px rgba(0, 0, 0, .075);
+          box-shadow: inset 0 3px 9px rgba(0, 0, 0, .075);
+}
+.navbar-brand,
+.navbar-nav > li > a {
+  text-shadow: 0 1px 0 rgba(255, 255, 255, .25);
+}
+.navbar-inverse {
+  background-image: -webkit-linear-gradient(top, #3c3c3c 0%, #222 100%);
+  background-image:      -o-linear-gradient(top, #3c3c3c 0%, #222 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#3c3c3c), to(#222));
+  background-image:         linear-gradient(to bottom, #3c3c3c 0%, #222 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff3c3c3c', endColorstr='#ff222222', GradientType=0);
+  filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
+  background-repeat: repeat-x;
+}
+.navbar-inverse .navbar-nav > .open > a,
+.navbar-inverse .navbar-nav > .active > a {
+  background-image: -webkit-linear-gradient(top, #080808 0%, #0f0f0f 100%);
+  background-image:      -o-linear-gradient(top, #080808 0%, #0f0f0f 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#080808), to(#0f0f0f));
+  background-image:         linear-gradient(to bottom, #080808 0%, #0f0f0f 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff080808', endColorstr='#ff0f0f0f', GradientType=0);
+  background-repeat: repeat-x;
+  -webkit-box-shadow: inset 0 3px 9px rgba(0, 0, 0, .25);
+          box-shadow: inset 0 3px 9px rgba(0, 0, 0, .25);
+}
+.navbar-inverse .navbar-brand,
+.navbar-inverse .navbar-nav > li > a {
+  text-shadow: 0 -1px 0 rgba(0, 0, 0, .25);
+}
+.navbar-static-top,
+.navbar-fixed-top,
+.navbar-fixed-bottom {
+  border-radius: 0;
+}
+.alert {
+  text-shadow: 0 1px 0 rgba(255, 255, 255, .2);
+  -webkit-box-shadow: inset 0 1px 0 rgba(255, 255, 255, .25), 0 1px 2px rgba(0, 0, 0, .05);
+          box-shadow: inset 0 1px 0 rgba(255, 255, 255, .25), 0 1px 2px rgba(0, 0, 0, .05);
+}
+.alert-success {
+  background-image: -webkit-linear-gradient(top, #dff0d8 0%, #c8e5bc 100%);
+  background-image:      -o-linear-gradient(top, #dff0d8 0%, #c8e5bc 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#dff0d8), to(#c8e5bc));
+  background-image:         linear-gradient(to bottom, #dff0d8 0%, #c8e5bc 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffdff0d8', endColorstr='#ffc8e5bc', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #b2dba1;
+}
+.alert-info {
+  background-image: -webkit-linear-gradient(top, #d9edf7 0%, #b9def0 100%);
+  background-image:      -o-linear-gradient(top, #d9edf7 0%, #b9def0 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#d9edf7), to(#b9def0));
+  background-image:         linear-gradient(to bottom, #d9edf7 0%, #b9def0 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffd9edf7', endColorstr='#ffb9def0', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #9acfea;
+}
+.alert-warning {
+  background-image: -webkit-linear-gradient(top, #fcf8e3 0%, #f8efc0 100%);
+  background-image:      -o-linear-gradient(top, #fcf8e3 0%, #f8efc0 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#fcf8e3), to(#f8efc0));
+  background-image:         linear-gradient(to bottom, #fcf8e3 0%, #f8efc0 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fffcf8e3', endColorstr='#fff8efc0', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #f5e79e;
+}
+.alert-danger {
+  background-image: -webkit-linear-gradient(top, #f2dede 0%, #e7c3c3 100%);
+  background-image:      -o-linear-gradient(top, #f2dede 0%, #e7c3c3 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f2dede), to(#e7c3c3));
+  background-image:         linear-gradient(to bottom, #f2dede 0%, #e7c3c3 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff2dede', endColorstr='#ffe7c3c3', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #dca7a7;
+}
+.progress {
+  background-image: -webkit-linear-gradient(top, #ebebeb 0%, #f5f5f5 100%);
+  background-image:      -o-linear-gradient(top, #ebebeb 0%, #f5f5f5 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#ebebeb), to(#f5f5f5));
+  background-image:         linear-gradient(to bottom, #ebebeb 0%, #f5f5f5 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffebebeb', endColorstr='#fff5f5f5', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar {
+  background-image: -webkit-linear-gradient(top, #428bca 0%, #3071a9 100%);
+  background-image:      -o-linear-gradient(top, #428bca 0%, #3071a9 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#428bca), to(#3071a9));
+  background-image:         linear-gradient(to bottom, #428bca 0%, #3071a9 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff428bca', endColorstr='#ff3071a9', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar-success {
+  background-image: -webkit-linear-gradient(top, #5cb85c 0%, #449d44 100%);
+  background-image:      -o-linear-gradient(top, #5cb85c 0%, #449d44 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#5cb85c), to(#449d44));
+  background-image:         linear-gradient(to bottom, #5cb85c 0%, #449d44 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff5cb85c', endColorstr='#ff449d44', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar-info {
+  background-image: -webkit-linear-gradient(top, #5bc0de 0%, #31b0d5 100%);
+  background-image:      -o-linear-gradient(top, #5bc0de 0%, #31b0d5 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#5bc0de), to(#31b0d5));
+  background-image:         linear-gradient(to bottom, #5bc0de 0%, #31b0d5 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff5bc0de', endColorstr='#ff31b0d5', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar-warning {
+  background-image: -webkit-linear-gradient(top, #f0ad4e 0%, #ec971f 100%);
+  background-image:      -o-linear-gradient(top, #f0ad4e 0%, #ec971f 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f0ad4e), to(#ec971f));
+  background-image:         linear-gradient(to bottom, #f0ad4e 0%, #ec971f 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff0ad4e', endColorstr='#ffec971f', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar-danger {
+  background-image: -webkit-linear-gradient(top, #d9534f 0%, #c9302c 100%);
+  background-image:      -o-linear-gradient(top, #d9534f 0%, #c9302c 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#d9534f), to(#c9302c));
+  background-image:         linear-gradient(to bottom, #d9534f 0%, #c9302c 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffd9534f', endColorstr='#ffc9302c', GradientType=0);
+  background-repeat: repeat-x;
+}
+.progress-bar-striped {
+  background-image: -webkit-linear-gradient(45deg, rgba(255, 255, 255, .15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, .15) 50%, rgba(255, 255, 255, .15) 75%, transparent 75%, transparent);
+  background-image:      -o-linear-gradient(45deg, rgba(255, 255, 255, .15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, .15) 50%, rgba(255, 255, 255, .15) 75%, transparent 75%, transparent);
+  background-image:         linear-gradient(45deg, rgba(255, 255, 255, .15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, .15) 50%, rgba(255, 255, 255, .15) 75%, transparent 75%, transparent);
+}
+.list-group {
+  border-radius: 4px;
+  -webkit-box-shadow: 0 1px 2px rgba(0, 0, 0, .075);
+          box-shadow: 0 1px 2px rgba(0, 0, 0, .075);
+}
+.list-group-item.active,
+.list-group-item.active:hover,
+.list-group-item.active:focus {
+  text-shadow: 0 -1px 0 #3071a9;
+  background-image: -webkit-linear-gradient(top, #428bca 0%, #3278b3 100%);
+  background-image:      -o-linear-gradient(top, #428bca 0%, #3278b3 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#428bca), to(#3278b3));
+  background-image:         linear-gradient(to bottom, #428bca 0%, #3278b3 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff428bca', endColorstr='#ff3278b3', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #3278b3;
+}
+.list-group-item.active .badge,
+.list-group-item.active:hover .badge,
+.list-group-item.active:focus .badge {
+  text-shadow: none;
+}
+.panel {
+  -webkit-box-shadow: 0 1px 2px rgba(0, 0, 0, .05);
+          box-shadow: 0 1px 2px rgba(0, 0, 0, .05);
+}
+.panel-default > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #f5f5f5 0%, #e8e8e8 100%);
+  background-image:      -o-linear-gradient(top, #f5f5f5 0%, #e8e8e8 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f5f5f5), to(#e8e8e8));
+  background-image:         linear-gradient(to bottom, #f5f5f5 0%, #e8e8e8 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff5f5f5', endColorstr='#ffe8e8e8', GradientType=0);
+  background-repeat: repeat-x;
+}
+.panel-primary > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #428bca 0%, #357ebd 100%);
+  background-image:      -o-linear-gradient(top, #428bca 0%, #357ebd 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#428bca), to(#357ebd));
+  background-image:         linear-gradient(to bottom, #428bca 0%, #357ebd 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff428bca', endColorstr='#ff357ebd', GradientType=0);
+  background-repeat: repeat-x;
+}
+.panel-success > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #dff0d8 0%, #d0e9c6 100%);
+  background-image:      -o-linear-gradient(top, #dff0d8 0%, #d0e9c6 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#dff0d8), to(#d0e9c6));
+  background-image:         linear-gradient(to bottom, #dff0d8 0%, #d0e9c6 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffdff0d8', endColorstr='#ffd0e9c6', GradientType=0);
+  background-repeat: repeat-x;
+}
+.panel-info > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #d9edf7 0%, #c4e3f3 100%);
+  background-image:      -o-linear-gradient(top, #d9edf7 0%, #c4e3f3 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#d9edf7), to(#c4e3f3));
+  background-image:         linear-gradient(to bottom, #d9edf7 0%, #c4e3f3 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffd9edf7', endColorstr='#ffc4e3f3', GradientType=0);
+  background-repeat: repeat-x;
+}
+.panel-warning > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #fcf8e3 0%, #faf2cc 100%);
+  background-image:      -o-linear-gradient(top, #fcf8e3 0%, #faf2cc 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#fcf8e3), to(#faf2cc));
+  background-image:         linear-gradient(to bottom, #fcf8e3 0%, #faf2cc 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fffcf8e3', endColorstr='#fffaf2cc', GradientType=0);
+  background-repeat: repeat-x;
+}
+.panel-danger > .panel-heading {
+  background-image: -webkit-linear-gradient(top, #f2dede 0%, #ebcccc 100%);
+  background-image:      -o-linear-gradient(top, #f2dede 0%, #ebcccc 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#f2dede), to(#ebcccc));
+  background-image:         linear-gradient(to bottom, #f2dede 0%, #ebcccc 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#fff2dede', endColorstr='#ffebcccc', GradientType=0);
+  background-repeat: repeat-x;
+}
+.well {
+  background-image: -webkit-linear-gradient(top, #e8e8e8 0%, #f5f5f5 100%);
+  background-image:      -o-linear-gradient(top, #e8e8e8 0%, #f5f5f5 100%);
+  background-image: -webkit-gradient(linear, left top, left bottom, from(#e8e8e8), to(#f5f5f5));
+  background-image:         linear-gradient(to bottom, #e8e8e8 0%, #f5f5f5 100%);
+  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffe8e8e8', endColorstr='#fff5f5f5', GradientType=0);
+  background-repeat: repeat-x;
+  border-color: #dcdcdc;
+  -webkit-box-shadow: inset 0 1px 3px rgba(0, 0, 0, .05), 0 1px 0 rgba(255, 255, 255, .1);
+          box-shadow: inset 0 1px 3px rgba(0, 0, 0, .05), 0 1px 0 rgba(255, 255, 255, .1);
+}
+/*# sourceMappingURL=bootstrap-theme.css.map */

Fichier diff supprimé car celui-ci est trop grand
+ 1 - 0
sources/public/bootstrap/css/bootstrap-theme.css.map


Fichier diff supprimé car celui-ci est trop grand
+ 5 - 0
sources/public/bootstrap/css/bootstrap-theme.min.css


Fichier diff supprimé car celui-ci est trop grand
+ 6358 - 0
sources/public/bootstrap/css/bootstrap.css


Fichier diff supprimé car celui-ci est trop grand
+ 1 - 0
sources/public/bootstrap/css/bootstrap.css.map


Fichier diff supprimé car celui-ci est trop grand
+ 5 - 0
sources/public/bootstrap/css/bootstrap.min.css


BIN
sources/public/bootstrap/fonts/glyphicons-halflings-regular.eot


Fichier diff supprimé car celui-ci est trop grand
+ 229 - 0
sources/public/bootstrap/fonts/glyphicons-halflings-regular.svg


BIN
sources/public/bootstrap/fonts/glyphicons-halflings-regular.ttf


BIN
sources/public/bootstrap/fonts/glyphicons-halflings-regular.woff


Fichier diff supprimé car celui-ci est trop grand
+ 2276 - 0
sources/public/bootstrap/js/bootstrap.js


Fichier diff supprimé car celui-ci est trop grand
+ 7 - 0
sources/public/bootstrap/js/bootstrap.min.js


+ 13 - 0
sources/public/bootstrap/js/npm.js

@@ -0,0 +1,13 @@
+// This file is autogenerated via the `commonjs` Grunt task. You can require() this file in a CommonJS environment.
+require('../../js/transition.js')
+require('../../js/alert.js')
+require('../../js/button.js')
+require('../../js/carousel.js')
+require('../../js/collapse.js')
+require('../../js/dropdown.js')
+require('../../js/modal.js')
+require('../../js/tooltip.js')
+require('../../js/popover.js')
+require('../../js/scrollspy.js')
+require('../../js/tab.js')
+require('../../js/affix.js')

+ 0 - 0
sources/public/css/style.css


Fichier diff supprimé car celui-ci est trop grand
+ 4 - 0
sources/public/jquery/jquery-2.1.1.min.js


+ 29 - 0
sources/public/js/custom.js

@@ -0,0 +1,29 @@
+$(document).ready(function() {
+  $('.btn-group').button();
+  $('[data-toggle="tooltip"]').tooltip();
+
+  $('.fileinput').click(function() {
+    var realinputid = '#' + $(this).attr('id').replace(/_chooser.*/, '');
+    $(realinputid).click();
+  });
+
+  $('input[type="file"]').change(function() {
+    var choosertxtid = '#' + $(this).attr('id') + '_choosertxt';
+    $(choosertxtid).val($(this).val());
+  });
+
+  $('.dropdown-menu li').click(function() {
+    var menu = $(this).parent();
+    var items = menu.children();
+    var button = menu.prev();
+    var input = button.prev();
+
+    items.removeClass('active');
+    $(this).addClass('active');
+
+    button.text($(this).text());
+    button.append(' <span class="caret"></span>');
+
+    input.attr('value', $(this).text());
+  });
+});

+ 39 - 0
sources/views/layout.html.php

@@ -0,0 +1,39 @@
+<!doctype html>
+<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="en"> <![endif]-->
+<!--[if IE 7]> <html class="no-js lt-ie9 lt-ie8" lang="en"> <![endif]-->
+<!--[if IE 8]> <html class="no-js lt-ie9" lang="en"> <![endif]-->
+<!--[if gt IE 8]><!--> <html class="no-js" lang="<?= $locale ?>"> <!--<![endif]-->
+<head>
+  <meta charset="utf-8">
+  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
+  <title>VPN Client <? echo (isset($title)) ? "| ".$title : "" ?></title>
+  <meta name="viewport" content="width=device-width">
+  <link media="all" type="text/css" href="<?= PUBLIC_DIR ?>/bootstrap/css/bootstrap.min.css" rel="stylesheet">
+  <link media="all" type="text/css" href="<?= PUBLIC_DIR ?>/bootstrap/css/bootstrap-theme.min.css" rel="stylesheet">
+  <link media="all" type="text/css" href="<?= PUBLIC_DIR ?>/css/style.css" rel="stylesheet">
+  <script src="<?= PUBLIC_DIR ?>/jquery/jquery-2.1.1.min.js"></script>
+  <script src="<?= PUBLIC_DIR ?>/bootstrap/js/bootstrap.min.js"></script>
+  <script src="<?= PUBLIC_DIR ?>/js/custom.js"></script>
+</head>
+<body>
+  <div class="container">
+    <? if (isset($flash['error'])) { ?>
+      <div class="alert alert-dismissible alert-danger fade in" style="margin-top: 20px" role="alert">
+        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
+        <strong><?= T_('Error') ?>:</strong> <?= $flash['error'] ?>
+      </div>
+    <? } elseif (isset($flash['notice'])) { ?>
+      <div class="alert alert-dismissible alert-info fade in" style="margin-top: 20px" role="alert">
+        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
+        <strong><?= T_('Notice') ?>:</strong> <?= $flash['notice'] ?>
+      </div>
+    <? } elseif (isset($flash['success'])) { ?>
+      <div class="alert alert-dismissible alert-success fade in" style="margin-top: 20px" role="alert">
+        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
+        <?= $flash['success'] ?>
+      </div>
+    <? } ?>
+
+    <?= $content?>
+</body>
+</html>

+ 133 - 0
sources/views/settings.html.php

@@ -0,0 +1,133 @@
+<h2><?= T_("Wifi Hotspot Configuration") ?></h2>
+
+<hr />
+
+<div class="row">
+  <div class="col-sm-offset-2 col-sm-8">
+    <form method="post" enctype="multipart/form-data" action="?/settings" class="form-horizontal" role="form">
+      <input type="hidden" name="_method" value="put" />
+
+      <div class="panel panel-default">
+        <div class="panel-heading">
+          <h3 class="panel-title"><?= T_("Wifi") ?></h3>
+        </div>
+
+        <div style="padding: 14px 14px 0 10px">
+          <div class="form-group">
+            <label for="wifi_ssid" class="col-sm-3 control-label"><?= T_('SSID') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="wifi_ssid" id="wifi_ssid" placeholder="myNeutralNetwork" value="<?= $wifi_ssid ?>" />
+            </div>
+          </div>
+  
+          <div class="form-group">
+            <label for="wifi_passphrase" class="col-sm-3 control-label"><?= T_('Passphrase (WPA2)') ?></label>
+            <div class="col-sm-9">
+              <input type="text" data-toggle="tooltip" data-title="<?= T_('At least 8 characters') ?>" class="form-control" name="wifi_passphrase" id="wifi_passphrase" placeholder="VhegT8oev0jZI" value="<?= $wifi_passphrase ?>" />
+            </div>
+          </div>
+  
+          <div class="form-group">
+            <label for="wifi_channel" class="col-sm-3 control-label"><?= T_('Channel') ?></label>
+            <div class="col-sm-9 input-group-btn">
+              <div class="input-group">
+                  <input type="text" name="wifi_channel" id="wifi_channel" value="<?= $wifi_channel ?>" style="display: none" />
+                  <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown"><?= $wifi_channel ?> <span class="caret"></span></button>
+                  <ul class="dropdown-menu dropdown-menu-left" role="menu">
+                    <li <?= $wifi_channel == 1 ? 'class="active"' : '' ?>><a href="#">1</a></li>
+                    <li <?= $wifi_channel == 2 ? 'class="active"' : '' ?>><a href="#">2</a></li>
+                    <li <?= $wifi_channel == 3 ? 'class="active"' : '' ?>><a href="#">3</a></li>
+                    <li <?= $wifi_channel == 4 ? 'class="active"' : '' ?>><a href="#">4</a></li>
+                    <li <?= $wifi_channel == 5 ? 'class="active"' : '' ?>><a href="#">5</a></li>
+                    <li <?= $wifi_channel == 6 ? 'class="active"' : '' ?>><a href="#">6</a></li>
+                    <li <?= $wifi_channel == 7 ? 'class="active"' : '' ?>><a href="#">7</a></li>
+                    <li <?= $wifi_channel == 8 ? 'class="active"' : '' ?>><a href="#">8</a></li>
+                    <li <?= $wifi_channel == 9 ? 'class="active"' : '' ?>><a href="#">9</a></li>
+                    <li <?= $wifi_channel == 10 ? 'class="active"' : '' ?>><a href="#">10</a></li>
+                    <li <?= $wifi_channel == 11 ? 'class="active"' : '' ?>><a href="#">11</a></li>
+                  </ul>
+              </div>
+            </div>
+          </div>
+  
+          <div class="form-group">
+            <label for="wifi_device" class="col-sm-3 control-label"><?= T_('Device') ?></label>
+            <div class="col-sm-9 input-group-btn">
+              <div class="input-group">
+                  <input type="text" name="wifi_device" id="wifi_device" value="<?= $wifi_device ?>" style="display: none" />
+                  <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown"><?= $wifi_device ?> <span class="caret"></span></button>
+                  <ul class="dropdown-menu dropdown-menu-left" role="menu">
+                    <?= $wifi_device_list ?>
+                  </ul>
+              </div>
+            </div>
+          </div>
+        </div>
+      </div>
+
+      <div class="panel panel-success">
+        <div class="panel-heading">
+          <h3 class="panel-title" data-toggle="tooltip" data-title="<?= T_('Real Internet') ?>"><?= T_("IPv6") ?></h3>
+        </div>
+
+        <div style="padding: 14px 14px 0 10px">
+          <div class="form-group">
+            <label for="ip6_net" class="col-sm-3 control-label"><?= T_('Delegated IPv6 subnet') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip6_net" id="ip6_net" placeholder="2001:db8:42::/48" value="<?= $ip6_net ?>" />
+            </div>
+          </div>
+
+          <div class="form-group">
+            <label for="ip6_dns0" class="col-sm-3 control-label"><?= T_('Frist DNS resolver') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip6_dns0" id="ip6_dns0" placeholder="2001:913::8" value="<?= $ip6_dns0 ?>" />
+            </div>
+          </div>
+
+          <div class="form-group">
+            <label for="ip6_dns1" class="col-sm-3 control-label"><?= T_('Second DNS resolver') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip6_dns1" id="ip6_dns1" placeholder="2001:910:800::40" value="<?= $ip6_dns1 ?>" />
+            </div>
+          </div>
+        </div>
+      </div>
+
+      <div class="panel panel-danger">
+        <div class="panel-heading">
+          <h3 class="panel-title" data-toggle="tooltip" data-title="<?= T_('Old Internet') ?>"><?= T_("IPv4") ?></h3>
+        </div>
+
+        <div style="padding: 14px 14px 0 10px">
+          <div class="form-group">
+            <label for="ip4_nat_prefix" class="col-sm-3 control-label"><?= T_('NAT prefix (/24)') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip4_nat_prefix" id="ip4_nat_prefix" placeholder="10.0.242" value="<?= $ip4_nat_prefix ?>" />
+            </div>
+          </div>
+
+          <div class="form-group">
+            <label for="ip4_dns0" class="col-sm-3 control-label"><?= T_('First DNS resolver') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip4_dns0" id="ip4_dns0" placeholder="80.67.188.188" value="<?= $ip4_dns0 ?>" />
+            </div>
+          </div>
+
+          <div class="form-group">
+            <label for="ip4_dns1" class="col-sm-3 control-label"><?= T_('Second DNS resolver') ?></label>
+            <div class="col-sm-9">
+              <input type="text" class="form-control" name="ip4_dns1" id="ip4_dns1" placeholder="80.67.169.12" value="<?= $ip4_dns1 ?>" />
+            </div>
+          </div>
+        </div>
+      </div>
+
+      <div class="form-group">
+        <div style="text-align: center">
+          <button type="submit" class="btn btn-default" data-toggle="tooltip" data-title="<?= T_('Reloading may take a few minutes. Be patient.') ?>"><?= T_('Save and reload') ?></button>
+        </div>
+      </div>
+    </form>
+  </div>
+</div>